;Lichtsteuerung fr Kay Bohn (c) www.hanneslux.de



.include "m32def.inc"       ;Namen fr Ports


;Konstanten:
.equ clock=14745600         ;Quarz 14,7456 MHz
.equ baud=9600              ;UART-Baudrate
.equ pwm_zu=100             ;PWM-Zhlumfang (100 Stufen)
.equ pwm_freq=100           ;PWM-Frequenz (100 Hz)
.equ bl_dauer=20            ;Dauer LCD-Backlight nach Tastendruck in Sekunden
.equ taku=10                ;Dauer kurzer Tastendruck in 10ms (Entprell)
.equ tala=100               ;Dauer langer Tastendruck in 10ms
.equ piepkurz=20            ;Dauer Tastenpiep bei kurzem Tastendruck

.equ pwm1_port=portb        ;erste 8 PWM-Kanle
.equ pwm1_ddr=ddrb
.equ pwm2_port=portc        ;zweite 8 PWM-Kanle
.equ pwm2_ddr=ddrc
.equ piep_port=porta        ;Tastenpiep
.equ piep_ddr=ddra
.equ piep_bit=pa5
.equ ecke_port=porta        ;Licht in der Ecke
.equ ecke_ddr=ddra
.equ ecke_bit=pa4


.equ ubrr=(clock/16/baud)-1 ;UART-Vorteiler berechnen
.equ t1_interval=clock/pwm_zu/pwm_freq  ;Timer-Intervall berechnen



.equ zln=4                  ;LCD mit 4 Zeilen je
.equ spn=40                 ;40 Zeichen (Spalten)

.equ bl_port=porta          ;Backlight
.equ bl_ddr=ddra
.equ bl_bit=pa6


.dseg                   ;SRAM-Variablen
vlcd:           .byte zln*spn   ;virt. Bildschirmspeicher
    .equ parapos=vlcd+105       ;Position der Parameteranzeige im LCD
pwmist:         .byte 16    ;Istwerte fr PWM
pwmsoll:        .byte 16    ;Sollwerte fr PWM
dimmpara:       .byte 16    ;Parameter (Dimmwerte) frs Men
menupara:       .byte 16    ;Parameter der Menpunkte
    .equ dimmkanal=menupara+3   ;zum Dimmen ausgewhlter PWM-Kanal
    .equ dimmwert=menupara+4    ;zum ausgewhlten Kanal gehrender Dimmwert
    .equ dimmtempo=menupara+5   ;Dimmtempo
    .equ shownr=menupara+12     ;Show-Nummer fr Liste
    .equ repeat=menupara+13     ;Anzahl Wiederholungen bei Lichtshow
showtempo:      .byte 1     ;Tempo der Lichtshow (in Sekunden)
rpos:           .byte 1     ;Leseposition VLCD
wpos:           .byte 1     ;Schreibposition VLCD
blinka:         .byte 1     ;Blinkbereich Anfang
blinke:         .byte 1     ;Blinkbereich Ende
tmpmath:        .byte 4     ;Uebergabebereich fuer Print
tast_alt:       .byte 1     ;alter Tastenwert
tast_akt:       .byte 1     ;aktuell gltiger (entprellter) Tastenwert
tast_prz:       .byte 1     ;Tasten-Prellzhler
maxpara:        .byte 1     ;max Parameterwert des akt. Menpunktes
showliste:      .byte 202   ;Liste mit Lichtshow-Nummern (+2 Dummies)
listindex:      .byte 1     ;Index innerhalb der Liste

;Variablen in Registern:
;untere Register
.def null=r2                ;immer Null
.def ff=r3                  ;immer 255
.def srsk=r4                ;SREG-Kopie fr ISRs
.def casa=r5                ;Carry-Sammler fr PWM in ISR
.def zvt=r6                 ;Zeitvorteiler 10ms -> 1s
.def bl_aus=r7              ;Timeout Backlight aus 
.def bliz=r8                ;Blinkzhler
.def piep=r9                ;Timeout Tastenpiep
.def mp=r10                 ;Menpunkt
.def ditz=r11               ;Dimmtempo-Zhler
.def zehner=r12             ;Zehner-Stelle fr Parameter
.def einer=r13              ;Einer-Stelle fr Parameter

;obere Register:

.def itmp=r18               ;Temporr in ISRs
.def pwz=r19                ;PWM-Zhler
.def flags=r20              ;Zustandsflags (BOOL'sche Variablen)
    .equ endshow=7              ;Ende-Flag Lichtshow-Datensatz
    .equ tkurz=6                ;Taste wurde (mindestens) kurz bettigt
    .equ tlang=5                ;Taste wurde lang bettigt
    .equ taste=4                ;Taste wurde bettigt und wieder losgelassen
    .equ para=3                 ;es sind Parameter anzuzeigen (oder nicht)
    .equ aktiv=2                ;Show ist aktiv

.def jobs=r21               ;Jobflags (BOOL'sche Variablen zur Steuerung)
    .equ husek=7                ;neue Hundertstelsekunde
    .equ neusek=6               ;neue Sekunde

.def tmp=r22                ;ungesichert temporr fr LCD
.def vflags=r23             ;Flags fr VLCD
.def wl=r24                 ;Working L (temporr)
.def wh=r25                 ;Working H (temporr)

;----------------------- Interrupt-Sprungtabelle --------------------------

.cseg       ;Code-Segment (Flash, Programmspeicher)
.org 0      ;Interrupt-Sprungtabelle ATmega32
 jmp RESET          ;Reset Handler
 jmp nix;EXT_INT0       ;IRQ0 Handler
 jmp nix;EXT_INT1       ;IRQ1 Handler
 jmp nix;EXT_INT2       ;IRQ2 Handler
 jmp nix;TIM2_COMP      ;Timer2 Compare Handler
 jmp nix;TIM2_OVF       ;Timer2 Overflow Handler
 jmp nix;TIM1_CAPT      ;Timer1 Capture Handler
 jmp TIM1_COMPA     ;Timer1 CompareA Handler
 jmp nix;TIM1_COMPB     ;Timer1 CompareB Handler
 jmp nix;TIM1_OVF       ;Timer1 Overflow Handler
 jmp nix;TIM0_COMP      ;Timer0 Compare Handler
 jmp nix;TIM0_OVF       ;Timer0 Overflow Handler
 jmp nix;SPI_STC        ;SPI Transfer Complete Handler
 jmp nix;USART_RXC      ;USART RX Complete Handler
 jmp nix;USART_UDRE     ;UDR Empty Handler
 jmp nix;USART_TXC      ;USART TX Complete Handler
 jmp nix;ADCC           ;ADC Conversion Complete Handler
 jmp nix;EE_RDY         ;EEPROM Ready Handler
 jmp nix;ANA_COMP       ;Analog Comparator Handler
 jmp nix;TWI            ;Two-wire Serial Interface Handler
 jmp nix;SPM_RDY        ;Store Program Memory Ready Handler
nix: reti

.include"pr_txt.inc"        ;LCD-Ausgabefunktionen fr Texte
.include"pr_i2a8.inc"       ;LCD-Ausgabefunktionen fr 8-Bit-Zahlen
.include"LCD_4x40.inc"      ;LCD-Treiber-Routinen fr LCDs mit 2 HD44780


reset:              ;Initialisierung
 ldi wl,low(ramend)         ;Stackpointer initialisieren
 out SPL,wl
 ldi wl,high(ramend)
 out SPH,wl
 clr null                   ;immer Null
 clr ff
 dec ff                     ;immer $ff
 ldi wl,100
 mov zvt,wl                 ;Startwert Zeitvorteiler 10ms -> 1s

 ldi wl,1<<acd              ;Analog-Comparator aus
 out acsr,wl                ;Strom sparen

 sbi bl_ddr,bl_bit          ;Backlight als Ausgang
 sbi piep_ddr,piep_bit      ;Piep als Ausgang
 sbi ecke_ddr,ecke_bit      ;Licht in der Ecke als Ausgang
 sbi ecke_port,ecke_bit     ;Licht in der Ecke erstmal ein

 out pwm1_port,null         ;PWM-Ports als
 out pwm2_port,null         ;Ausgang
 out pwm1_ddr,ff            ;und erstmal aus
 out pwm2_ddr,ff

 sbi porta,1                ;unbenutzte Ports
 sbi porta,2                ;PullUp
 sbi porta,3                ;einschalten

 ldi wl,(1<<refs0)|(1<<adlar)   ;VCC als Referenz, linksbndige Ausgabe,
 out admux,wl               ;ADC0 als Messpunkt
 ldi wl,(1<<aden)|(1<<adsc)|(1<<adate)|7    ;ADC freilaufend mitVorteiler 128
 out adcsra,wl              ;starten

 ldi wl,1<<se               ;Sleep-Mode Idle aktivieren
 out mcucr,wl

 ldi wl,(1<<wgm12)|(1<<cs10);Timer1 mit 
 out tccr1b,wl              ;Vorteiler 1:1 starten
 ldi wl,low(t1_interval)    ;Interrupt-
 ldi wh,high(t1_interval)   ;Intervall
 out ocr1ah,wh              ;Timer1
 out ocr1al,wl              ;setzen
 ldi wl,1<<ocie1a           ;OCR1A-Int 
 out timsk,wl               ;freischalten
 rcall lcd_init             ;LCD initialisieren
 sei                        ;Interrupts freigeben

 clr r0                     ;Dimmwert-Speicherplatz 0
 ldi zl,low(pwmist)         ;Pointer auf Anfang
 ldi zh,high(pwmist)        ;Array mit Soll- und Ist-Werten
reset1:
 out eearh,null             ;EEP 
 out eearl,r0               ;adressieren
 sbi eecr,eere              ;und 
 in wl,eedr                 ;lesen,
 lsr xh                     ;0-Bit in X nach
 ror xl                     ;rechts schieben
 sbrc wl,7                  ;Zusatzbit im Dimmwert gesetzt? - nein...
 sbr xh,128                 ;ja, im Shiftregister setzen
 andi wl,127                ;ohne oberes Bit als
 std z+48,null              ;0 als Start fr Menparameter voreinstellen
 std z+32,wl                ;Dimmwerte als Startwerte frs Men voreinstellen
 std z+16,wl                ;als Sollwert (Zielwert) sichern
 st z+,null                 ;0 als Start fr Istwert (Nachlaufwert) sichern
 inc r0                     ;nchster Dimmwert
 cpi zl,low(pwmist+16)      ;alle 16 Parameter fertig?
 brne reset1                ;fertig? - nein...
 andi xl,127                ;nur die unteren 7 Bit bercksichtigen
 sts dimmtempo,xl           ;und als Dimmtempo werten

 ldi zl,low(showliste)      ;Showliste
 ldi zh,high(showliste)     ;lschen
reset2:
 st z+,ff                   ;$ff kennzeichnet ungltige Shownummer
 st z+,null                 ;Wiederholungen auf 0
 cpi zl,low(showliste+202)  ;Ende (incl. Dummies) erreicht?
 brne reset2                ;nein, nochmal

 ldi wl,30                  ;30 Sekunden
 mov bl_aus,wl              ;LCD-Beleuchtung
 sbi bl_port,bl_bit         ;einschalten
 mov piep,wl                ;300 ms piepen
 sbi piep_port,piep_bit     ;einschalten
 ldi wl,10
 mov mp,wl
 rjmp menu_on

;-- Hauptschleife  -----------------------------------------------------------
mainloop:               ;Hauptschleife
 sbrc jobs,husek            ;Hundertstelsekunde um? - nein...
 rjmp hundertstel           ;ja...
 sbrc jobs,neusek           ;eine Sekunde um? - nein...
 rjmp neue_sekunde          ;ja...
 sbrc vflags,upsync         ;LCD updaten? - nein...
 rcall lcd_update           ;ja, ein Zeichen ausgeben...
 sbrc flags,tlang
 rjmp neucharlang
 sbrc flags,taste
 rjmp neuchar
 sleep                      ;auf Interrupt warten...
 rjmp mainloop              ;nochmal


;-- Jobs der Hauptschleife ---------------------------------------------------
;Sondertasten (bedingte Sprungziele)
downtastelang:          ;C-Down wurde lange gedrckt
 ldi wl,1<<ecke_bit         ;zu nderndes Bit 
 in wh,ecke_port            ;des Ports
 eor wh,wl                  ;toggeln und
 out ecke_port,wh           ;zurckschreiben
 rjmp mainloop              ;fertig...

uptastelang:            ;C-Up wurde lange gedrckt
 ldi wl,1<<ecke_bit         ;zu nderndes Bit 
 in wh,ecke_port            ;des Ports
 eor wh,wl                  ;toggeln und
 out ecke_port,wh           ;zurckschreiben
 rjmp mainloop              ;fertig...


;-- langer Tastendruck -------------------------------------------------------
neucharlang:            ;neuer langer Tastendruck eingetroffen
 cbr flags,1<<tlang         ;Flag lschen
 lds wl,tast_akt            ;Tastenwert holen
 sts tast_akt,null          ;und entwerten
                        ;Sonder-Tasten?
 cpi wl,128                 ;Down-Taste?
 breq downtastelang         ;ja, abarbeiten...

 cpi wl,64                  ;Up-Taste?
 breq uptastelang           ;ja, abarbeiten...
                        ;nun bleiben nur die Ziffern 0 bis 9 brig
 andi wl,15                 ;ASCII-Bereich ausblenden
 mov mp,wl                  ;als Menpunktnummer

menu_on:                ;Dialogtext einblenden
 ldi tmp,' '                ;Leerzeichen
 ldi zl,low(vlcd+16)        ;Zeile 1 und 2
 ldi zh,high(vlcd+16)       ;LCD-Spalten 16 bis 39 lschen
neucharlang1:
 std z+40,tmp               ;
 st z+,tmp                  ;
 cpi zl,low(vlcd+40)        ;
 brne neucharlang1          ;
 ldi zl,low(vlcd+96)        ;Zeile 3 und 4
 ldi zh,high(vlcd+96)       ;LCD-Spalten 16 bis 39 lschen
neucharlang2:
 std z+40,tmp               ;
 st z+,tmp                  ;
 cpi zl,low(vlcd+120)       ;
 brne neucharlang2          ;

            locate 3,37
            print8 mp

 printt mt,mp               ;Mentext ausgeben
 tst mp                     ;Menpunkt Show-Edit?
 brne neucharlang2b         ;nein...
 rjmp printliste            ;ja, Show-Liste ausgeben...
neucharlang2b:
 ldi zl,4                   ;Menpunkt Dimmen
 cp mp,zl                   ;aktiv?
 brne neucharlang2a         ;nein...
 locate 0,32                ;Kanalnummer
 print8s menupara+3         ;anzeigen
neucharlang2a:          ;Maximalwert Parameter ermitteln
 ldi zl,low(maxparalist*2)  ;Pointer auf Anfang der Liste 
 ldi zh,high(maxparalist*2) ;mit Maxwerten setzen,
 add zl,mp                  ;Menpunkt
 adc zh,null                ;als Index
 lpm r1,z                   ;Maxwert holen
 sts maxpara,r1             ;und sichern
 cbr flags,1<<para          ;erstmal keine Parametereingaben vermuten
 tst r1                     ;hat dieser MP berhaupt Parametereingabe?
 breq neucharlang3          ;nein...
 sbr flags,1<<para          ;Parametereingaben freischalten
 ldi zl,low(menupara)       ;Parameter aus SRAM-Array holen
 ldi zh,high(menupara)      ;
 add zl,mp                  ;
 adc zh,null                ;
 ld wl,z                    ;Datenbyte holen
 ldi tmp,-1+'0'             ;Zehner-Stelle als ASCII-Zeichen, Zahl ber 0
 mov zehner,tmp             ;
 inc zehner                 ;Zehner hoch und
 subi wl,10                 ;10 subtrahieren bis zum Unterlauf
 brsh pc-2                  ;Unterlauf? nein, 2 Zeilen hoch
 ldi tmp,10+'0'             ;Einer-Stelle als ASCII-Zeichen, Zahl unter 0
 mov einer,tmp              ;ASCII-Zeichen fr Einer-Stelle kopieren...
 add einer,wl               ;Zahlenwert dazu
 sts parapos,zehner         ;Wert
 sts parapos+1,einer        ;anzeigen
 sbr vflags,1<<update       ;neue Zeichen anmelden
neucharlang3:
 rjmp mainloop              ;fertig...


;-- kurzer Tastendruck -------------------------------------------------------
neuchar:                ;neuer kurzer Tastendruck eingetroffen
 cbr flags,1<<taste
 lds wl,tast_akt            ;Tastenwert holen
 ldi wh,10                  ;Begrungs-Text 
 cp mp,wh                   ;Begrungs-Menpunkt?
 ldi wh,11                  ;anschlieend folgt Info-Text 
 brne neuchar00             ;nein...
 mov mp,wh                  ;MP11 (Info-Text) auswhlen und
 rjmp menu_on               ;Dialogtext einblenden...

neuchar00:
 tst mp                     ;Menpunkt 0 (Lichtshow) aktiv?
 brne neuchar01             ;nein, weiter...
 rjmp showmenu              ;ja, separat behandeln...

neuchar01:
 cp mp,wh                   ;Info-Menpunkt?
 brne neuchar0              ;nein...
 andi wl,15                 ;Aus ASCII-Ziffer Ziffernwert extrahieren
 mov mp,wl                  ;und als 
 rjmp menu_on               ;Menpunkt werten...

neuchar0:
 cp mp,ff                   ;Men aktiv?
 brne neuchar1              ;ja...
 mov mp,wh                  ;MP11 (Info-Text) auswhlen und
 rjmp menu_on               ;Dialogtext einblenden...

neuchar1:
; sts tast_akt,null
; rcall lcd_data
                        ;Sonder-Tasten?
 cpi wl,128                 ;Down-Taste?
 breq downtastekurz         ;ja, abarbeiten...

 cpi wl,64                  ;Up-Taste?
 breq uptastekurz           ;ja, abarbeiten...

                        ;nun bleiben nur die Ziffern 0 bis 9 brig
 sbrs flags,para            ;hat dieser Menpunkt Parameter? - ja...
 rjmp neuchar2              ;nein, Tastendruck ignorieren...
 locate 3,16                ;evtl. Fehlermeldung 
 printf txt_leerzeile       ;lschen
 mov zehner,einer           ;Einer-Wert nach links (Zehner) schieben
 mov einer,wl               ;Tastenwert als Einer werten
 sts parapos,zehner         ;Wert
 sts parapos+1,einer        ;anzeigen
 sbr vflags,1<<update       ;neue Zeichen anmelden

neuchar2:
 rjmp mainloop              ;fertig...

downtastekurz:          ;Downtaste (ESC) wurde bei aktivem Men kurz gerckt
 mov mp,ff                  ;Men deaktivieren
 rjmp mainloop              ;fertig...

uptastekurz1:           ;Parameter-Wert ungltig
 locate 3,16                ;in letzte Menzeile
 printf txt_badpara         ;Fehlermeldung zeigen
 rjmp mainloop              ;fertig...

uptastekurz:            ;Uptaste (Enter) wurde bei aktivem Men kurz gerckt
 sbrs flags,para            ;hat der Menpunkt Parameter? - ja...
 rjmp menu                  ;nein, Parameter ignorieren...

 locate 3,16                ;letzte Menzeile (Fehlermeldung)
 printf txt_leerzeile       ;vorsorglich lschen
 ldi wh,10                  ;Multiplikator
 mov wl,zehner              ;aus ASCII-Ziffer (Zehner)
 andi wl,15                 ;Zahlenwert ermitteln
 mul wl,wh                  ;und mit 10 multiplizieren,
 mov wl,einer               ;aus ASCII-Ziffer (Einer)
 andi wl,15                 ;Zahlenwert ermitteln
 add r0,wl                  ;und dazu addieren,
 lds r1,maxpara             ;Parameter-Max-Wert dieses MP nach r1 holen
 cp r1,r0                   ;ist der erlaubte Maxwert berschritten?
 brcs uptastekurz1          ;ja, Benutzer beschimpfen...
 ldi zl,low(menupara)       ;nein, Wert sichern
 ldi zh,high(menupara)      ;Pointer auf Menparameterliste
 add zl,mp                  ;Menpunkt als
 adc zh,null                ;Offset
 st z,r0                    ;Menparameter sichern

menu:                   ;Menjobs
 ldi zl,low(menutab)        ;Pointer auf Anfang
 ldi zh,high(menutab)       ;Men-Sprungtabelle
 add zl,mp                  ;Menpunkt 
 adc zh,null                ;mit bertrag dazu
 ijmp                       ;Sprung nach (Z)...


menutab:                ;Adressen der Menpunkte
 rjmp mp00                  ;Aufruf Menjob 0 (Untermen Lichtshow)
 rjmp mp01                  ;Aufruf Menjob 1 (Einstellung aus EEP laden)
 rjmp mp02                  ;Aufruf Menjob 2 (Einstellung in EEP speichern)
 rjmp mp03                  ;Aufruf Menjob 3 (Eingabe PWM-Kanalnummer)
 rjmp mp04                  ;Aufruf Menjob 4 (Eingabe Dimmwert)
 rjmp mp05                  ;Aufruf Menjob 5 (Eingabe Dimmtempo)
 rjmp mainloop              ;Aufruf Menjob 6 (Reserve)
 rjmp mainloop              ;Aufruf Menjob 7 (Reserve)
 rjmp mainloop              ;Aufruf Menjob 8 (Reserve)
 rjmp mainloop              ;Aufruf Menjob 9 (Reserve)
 rjmp mainloop              ;Begrungstext, kein Menjob, fertig...
 rjmp mainloop              ;Info-Text, kein Menjob, fertig...
 rjmp mp12                  ;Aufruf Menjob 12 (bernahme Showdaten Nr.)
 rjmp mp13                  ;Aufruf Menjob 13 (bernahme Showdaten Anz.)


showmenu:               ;Untermen innerhalb MP0 zum Erstellen von Lichtshows
;der neue Tastendruck ist in wl
 ldi zl,low(showmenutab)    ;Pointer auf Anfang
 ldi zh,high(showmenutab)   ;Men-Sprungtabelle
 andi wl,15                 ;aus ASCII-Ziffer Werte extrahieren
 add zl,wl                  ;Untermenpunkt 
 adc zh,null                ;mit bertrag dazu
 lds wh,listindex           ;Listindex holen
 ijmp                       ;Sprung nach (Z)...

showmenutab:            ;Adressen der Untermenpunkte
 rjmp sm00                  ;Aufruf Show-Menjob 
 rjmp sm01                  ;Aufruf Show-Menjob 
 rjmp sm02                  ;Aufruf Show-Menjob 
 rjmp sm03                  ;Aufruf Show-Menjob 
 rjmp sm04                  ;Aufruf Show-Menjob 
 rjmp sm05                  ;Aufruf Show-Menjob 
 rjmp sm06                  ;Aufruf Show-Menjob 
 rjmp sm07                  ;Aufruf Show-Menjob 
 rjmp sm08                  ;Aufruf Show-Menjob 
 rjmp sm09                  ;Aufruf Show-Menjob 

sm00:                   ;delete all
 ldi zl,low(showliste)      ;Pointer auf Anfang
 ldi zh,high(showliste)     ;Showliste
sm00a:
 st z+,ff                   ;Eintrag ungltig machen
 cpi zl,low(showliste+200)  ;Liste zu Ende?
 brne sm00a                 ;nein, nochmal
 ;Code geht weiter...

sm01:                   ;Home
 sts listindex,null         ;erste Listenzeile
 rjmp printliste            ;Liste ausgeben...

sm02:                   ;Scroll minus 1
 ldi wl,1                   ;Decrement 1
sm02a:                  ;Einsprung
 sub wh,wl                  ;Listindex vermindern
 sbrc wh,7                  ;Unterlauf? - nein...
 ldi wh,0                   ;ja, begrenzen
 sts listindex,wh           ;Listindex sichern
 rjmp printliste            ;Liste ausgeben...

sm03:                   ;Scroll minus 10
 ldi wl,10                  ;Decrement 10
 rjmp sm02a                 ;weiter wie bei -1

sm04:                   ;aktuelle Show aus Liste entfernen
 ldi zl,low(showliste)      ;Pointer auf Anfang
 ldi zh,high(showliste)     ;Showliste
 lsr wh                     ;Listindex mal 2 (zwei Bytes je Datensatz)
 add zl,wh                  ;Index
 adc zh,null                ;mit bertrag adieren
sm04a:                  ;Loop
 ldd r0,z+2                 ;Shownummer vom nchsten Datensatz holen
 ldd r1,z+3                 ;Wiederholungen vom nchsten Datensatz holen
 st z+,r0                   ;und (mit Increment)
 st z+,r1                   ;in aktuellen Datensatz speichern
 cpi zl,low(showliste+200)  ;Ende der Liste erreicht?
 brne sm04a                 ;nein, nochmal...
 rjmp printliste            ;Liste ausgeben...

sm05:                   ;Eingabe/nderung Shownummer
 ldi tmp,12                 ;Menpunkt 12 
sm05a:
 mov mp,tmp
 rjmp menu_on               ;vortuschen...

sm06:                   ;Eingabe/nderung Wiederholungen
 ldi tmp,13                 ;Menpunkt 13 
 rjmp sm05a                 ;vortuschen...

sm07:                   ;End (letzter benutzter Listeneintrag)
 ldi zl,low(showliste)      ;Pointer auf Anfang
 ldi zh,high(showliste)     ;Showliste
sm07a:                  ;Loop
 ld r0,z+                   ;Eintrag (Shownummer) holen
 ld r1,z+                   ;Dummy wegen Pointer-Increment
 cp r0,ff                   ;Eintrag leer?
 breq sm07b                 ;ja, Abbruch...
 cpi zl,low(showliste+200)  ;Liste zu Ende?
 brne sm07a                 ;nein, nochmal...
 ldi zl,99                  ;Liste voll, Index auf letzten 
 rjmp sm07c                 ;Eintrag setzen...
sm07b:                  ;ersten ungltigen Eintrag gefunden
 subi zl,low(showliste)     ;Basisadresse vom Pointer
 sbci zh,high(showliste)    ;subtrahieren,
 lsr zl                     ;durch 2 teilen (2 Eintrge je Datensatz)
sm07c:
 sts listindex,zl           ;als Listindex speichern und
 rjmp printliste            ;Liste ausgeben...

sm08:                   ;Scroll plus 1
 ldi wl,1                   ;Increment 1
sm08a:                  ;Einsprung
 add wh,wl                  ;Listindex erhhen
 cpi wh,100                 ;berlauf?
 brcs sm08b                 ;nein...
 ldi wh,99                  ;ja, begrenzen
sm08b:
 sts listindex,wh           ;Listindex sichern
 rjmp printliste            ;Liste ausgeben...

sm09:                   ;Scroll plus 10
 ldi wl,10                  ;Increment 10
 rjmp sm08a                 ;weiter wie bei +1


printliste:             ;Gibt Show-Liste auf Display aus
 ldi zl,low(showliste)      ;Pointer auf Anfang
 ldi zh,high(showliste)     ;Showliste
 lds wh,listindex           ;Listindex (Zeile in Liste) holen
 lsl wh                     ;Listindex mal 2 (zwei Bytes je Datensatz)
 add zl,wh                  ;Index
 adc zh,null                ;mit bertrag adieren
 lsr wh                     ;Listindex wieder korrekt
 sbiw zh:zl,2               ;2 Bytes zurck, um alle 6 Bytes lesen zu knnen
 locate 1,0                 ;Position obere Listen-Zeile
 cpi wh,0                   ;Zeile 0 (erster Eintrag)?
 breq printliste0           ;ja, obere Zeile nicht ausgeben...
 mov wl,wh                  ;Index kopieren
 dec wl                     ;Zeilennummer -1
 rcall prili                ;ausgeben
 ldi tmp,':'                ;Trennzeichen
 rcall lcd_data             ;ausgeben
 ldd wl,z+0                 ;Shownummer von Zeile-1 holen
 rcall prili                ;ausgeben
 ldi tmp,' '                ;Leerzeichen
 rcall lcd_data             ;zweimal...
 rcall lcd_data             ;ausgeben...
 ldd wl,z+1                 ;Wiederholungen von Zeile-1 holen
 rcall prili                ;ausgeben
 rjmp printliste1           ;weiter...
printliste0:
 printf txt_leer16          ;alte Ausgabe lschen
printliste1:
 locate 2,0                 ;Position mittlere Listen-Zeile
 mov wl,wh                  ;Index kopieren
 rcall prili                ;ausgeben
 ldi tmp,':'                ;Trennzeichen
 rcall lcd_data             ;ausgeben
 ldd wl,z+2                 ;Shownummer von Zeile holen
 rcall prili                ;ausgeben
 ldi tmp,' '                ;Leerzeichen
 rcall lcd_data             ;zweimal...
 rcall lcd_data             ;ausgeben...
 ldd wl,z+3                 ;Wiederholungen von Zeile holen
 rcall prili                ;ausgeben
 locate 3,0                 ;Position untere Listen-Zeile
 cpi wh,99                  ;letzter Eintrag?
 breq printliste2           ;ja, untere Zeile nicht ausgeben...
 mov wl,wh                  ;Index kopieren
 inc wl                     ;Zeilennummer -1
 rcall prili                ;ausgeben
 ldi tmp,':'                ;Trennzeichen
 rcall lcd_data             ;ausgeben
 ldd wl,z+4                 ;Shownummer von Zeile-1 holen
 rcall prili                ;ausgeben
 ldi tmp,' '                ;Leerzeichen
 rcall lcd_data             ;zweimal...
 rcall lcd_data             ;ausgeben...
 ldd wl,z+5                 ;Wiederholungen von Zeile-1 holen
 rcall prili                ;ausgeben
 rjmp printliste3           ;weiter...
printliste2:
 printf txt_leer16          ;alte Ausgabe lschen
printliste3:
 rjmp mainloop              ;fertig...


;-- Hauptmenpunkte bzw. deren Jobs ------------------------------------------
mp00:                   ;Menpunkt-Job "Start Lichtshow"
 mov mp,ff                  ;Men aus
 sbr flags,1<<aktiv         ;Show-aktiv-Flag setzen
 rjmp mainloop              ;fertig...

mp01:                   ;Menpunkt-Job "Einstellung laden"
 ldi wl,16                  ;Multiplikator
 ldi zl,low(pwmsoll)        ;Pointer auf
 ldi zh,high(pwmsoll)       ;Anfang Sollwertliste
 mul r0,wl                  ;EEP-Adresse berechnen (Parameter * 16)
 out eearh,r1               ;EEP-Adr. High (bleibt innerhalb der 16 Bytes)
mp01a:                  ;Loop
 out eearl,r0               ;EEP-Adresse Low setzen
 sbi eecr,eere              ;Lesebefehl geben
 in wl,eedr                 ;Datenbyte holen
 lsr xh                     ;0-Bit in X nach
 ror xl                     ;rechts schieben
 sbrc wl,7                  ;Zusatzbit im Dimmwert gesetzt? - nein...
 sbr xh,128                 ;ja, im Shiftregister setzen
 andi wl,127                ;ohne oberes Bit als
 std z+16,wl                ;Dimmparameter fr Men und
 st z+,wl                   ;Sollwert speichern
 inc r0                     ;EEP-Adresse erhhen
 cpi zl,low(pwmsoll+16)     ;alle 16 Parameter fertig?
 brne mp01a                 ;nein, nochmal...
 andi xl,127                ;nur die unteren 7 Bit bercksichtigen
 sts dimmtempo,xl           ;und als Dimmtempo werten
 rjmp okay                  ;fertig...

mp02:                   ;Menpunkt-Job "Einstellung speichern"
 locate 3,16                ;in letzte Menzeile
 printf txt_save            ;Statusmeldung ausgeben
 sbic eecr,eewe             ;EEP busy? - nein...
 rjmp mp02                  ;ja, warten...
 ldi wl,16                  ;Multiplikator
 ldi zl,low(pwmsoll)        ;Pointer auf
 ldi zh,high(pwmsoll)       ;Anfang Sollwertliste
 mul r0,wl                  ;EEP-Adresse berechnen (Parameter * 16)
 out eearh,r1               ;EEP-Adr. High (bleibt innerhalb der 16 Bytes)
 lds xl,dimmtempo           ;Dimmtempo in Shiftregister 
mp02a:                  ;Loop
 sbic eecr,eewe             ;EEP busy? - nein...
 rjmp mp02a                 ;ja, warten...
 out eearl,r0               ;EEP-Adresse Low setzen
 ldd wl,z+16                ;Dimmparameter (vom Men) holen
 lsr xl                     ;
 brcc mp02b                 ;
 sbr wl,128                 ;
mp02b:
 out eedr,wl                ;und ins EEP schreiben
 cli                        ;Interrupt sperren
 sbi eecr,eemwe             ;Schreibschutz aufheben
 sbi eecr,eewe              ;Schreibbefehl geben
 sei                        ;Interrupt wieder freigeben
 inc r0                     ;EEP-Adresse erhhen
 adiw zh:zl,1               ;SRAM-Adresse erhhen
 cpi zl,low(pwmsoll+16)     ;alle 16 Parameter fertig?
 brne mp02a                 ;nein, nochmal...
 rjmp okay                  ;fertig...

mp03:                   ;Menpunkt-Job "Kanal zum Dimmen auswhlen"
 ldi zl,low(dimmpara)       ;Pointer
 ldi zh,high(dimmpara)      ;
 add zl,r0                  ;
 adc zh,null                ;
 ld tmp,z                   ;
 sts dimmwert,tmp           ;
 inc mp                     ;MP4 (Dimmen)
 rjmp menu_on               ;aufrufen

mp04:                   ;Menpunkt-Job "Dimmen (Helligkeit einstellen)"
 ldi zl,low(pwmsoll)        ;Pointer auf Liste mit
 ldi zh,high(pwmsoll)       ;Dimmwerten
 lds wl,dimmkanal           ;Kanalnummer holen
 add zl,wl                  ;und
 adc zh,null                ;mit bertrag addieren
 std z+16,r0                ;Parameter als Dimmpara sichern,
 st z,r0                    ;als PWM-Sollwert bernehmen
 sts dimmwert,r0            ;und als Vorgabe fr nchsten Men-Aufruf
 dec mp                     ;Menpunkt 3
 rjmp menu_on               ;aufrufen

mp05:                   ;Menpunkt-Job "Dimmtempo"
 rjmp mainloop              ;fertig...

mp06:                   ;noch kein Menpunkt-Job 
 rjmp mainloop              ;fertig...

mp07:                   ;noch kein Menpunkt-Job 
 rjmp mainloop              ;fertig...

mp08:                   ;noch kein Menpunkt-Job 
 rjmp mainloop              ;fertig...

mp09:                   ;noch kein Menpunkt-Job 
 rjmp mainloop              ;fertig...

mp12:                   ;Menpunkt-Job "Show zu Liste hinzufgen"
 inc mp                     ;MP13 (Eingabe Wiederholungen) folgt
mp12a:
 ldi zl,low(showliste)      ;Pointer auf Anfang der
 ldi zh,high(showliste)     ;Liste mit Show-Eintrgen,
 lds wl,listindex           ;momentanen Index in der Liste holen
 lsl wl                     ;2 Bytes je Listen-Eintrag
 add zl,wl                  ;Index dazu
 adc zh,null                ;mit bertrag
 lds wl,shownr              ;ausgewhlte Sequenz-Nummer holen
 st z,wl                    ;und in Liste eintragen (erstes Byte je Eintrag)
 lds wl,repeat              ;Anzahl Wiederholungen holen
 std z+1,wl                 ;und in Liste eintragen (zweites Byte je Eintrag)
; locate 0,16                ;in rechten Teil des LCDs
; printt mt,mp               ;Benutzerfhrung anzeigen
 rjmp menu_on               ;links aktualisierte Showliste anzeigen

mp13:                   ;Menpunkt-Job "Anzahl Wiederholungen"
 clr mp                     ;anschlieend zurck zur Show-Liste
 rjmp mp12a                 ;weiter wie bei Shownummer...

okay:                   ;
 locate 3,16                ;Ausgabeposition fr Meldung
 printf txt_ok              ;Meldung ausgeben
 ldi wl,3                   ;verkrztes Timeout fr
 mov bl_aus,wl              ;LCD-Licht setzen
 rjmp mainloop              ;fertig...


;-- Jobs, die alle 10ms aufgerufen werden ------------------------------------
hundertstel:            ;Job der Mainloop, Hundertstelsekunde vergangen
 cbr jobs,1<<husek          ;Jobflag lschen
;Sekundentakt erzeugen
 dec zvt                    ;Vorteiler 10ms -> 1s
 brne hundertstel1          ;bergelaufen? - nein...
 sbr jobs,1<<neusek         ;neue Sekunde fr andere Jobs anmelden
 ldi wl,100                 ;Vorteiler
 mov zvt,wl                 ;auf Startwert

hundertstel1:           ;Timeout Tastenpiep
 tst piep                   ;Timeout aktiv?
 breq entprell              ;nein...
 dec piep                   ;ja, runterzhlen
 brne entprell              ;abgelaufen? - nein...
 cbi piep_port,piep_bit     ;ja, ausschalten

entprell:               ;Tastenentprellung
 in wl,adch                 ;ADC einlesen (0..255)
 lsr wl                     ;durch 8 teilen (0..31)
 lsr wl
 lsr wl

;Debug, Anzeige des Scannwertes der Taste am Display
            locate 3,37
            print8 wl
;Ende Debug...


 ldi zl,low(tastenwerte*2)  ;Pointer auf Tabelle
 ldi zh,high(tastenwerte*2) ;mit Tastenwerten
 add zl,wl                  ;Scannwert und
 adc zh,null                ;bertrag addieren
 lpm                        ;Wert nach r0 holen
 tst r0                     ;war eine Taste gedrckt?
 brne entprell1             ;ja...
                        ;keine Taste gedrckt
 sbrc flags,tkurz           ;war zuvor eine Taste kurz gedrckt? - nein...
 sbr flags,1<<taste         ;ja, Tastendruck anmelden,
 cbr flags,1<<tkurz         ;Kurzflag lschen
 sts tast_alt,null          ;alten Tastendruck verwerfen
 sts tast_prz,null          ;Prellzhler lschen
 rjmp entprellende          ;fertig...
entprell1:              ;Taste war gedrckt
 lds wl,tast_alt            ;letzten Tastenwert holen
 cp r0,wl                   ;und vergleichen
 breq entprell2             ;gleich? - ja...
 sts tast_alt,r0            ;nein, neuen Tastendruck merken
 sts tast_prz,null          ;Prellzhler lschen
 rjmp entprellende          ;fertig...
entprell2:              ;dieselbe Taste ist immernoch gedrckt
 lds wl,tast_prz            ;Prellzhler holen,
 inc wl                     ;erhhen
 brne entprell3             ;berlauf
 dec wl                     ;verhindern
entprell3:
 sts tast_prz,wl            ;und wieder sichern
                        ;Test auf kurzen Tastendruck
 cpi wl,taku                ;Prellzeit kurz erreicht?
 brne entprell4             ;nein...
 sts tast_akt,r0            ;ja, Tastenwert sichern
 sbr flags,1<<tkurz         ;Taste anmelden
 ldi wh,piepkurz            ;Tastenpiep-Timeout 
 mov piep,wh                ;setzen
 sbi piep_port,piep_bit     ;Piep einschalten
entprell4:              ;Test auf langen Tastendruck
 cpi wl,tala                ;Prellzeit lang
 brcs entprell6             ;noch unterschritten? - ja...
 brne entprell5             ;bereits berschritten? - ja...
 sbr flags,1<<tlang         ;genau erreicht? ja, Flag setzen
 cbr flags,1<<tkurz         ;und kurzen Tastendruck canceln
entprell5:              ;langer Tastendruck erreicht oder berschritten
 ldi wh,piepkurz            ;Tastenpiep-Timeout 
 mov piep,wh                ;setzen
 sbi piep_port,piep_bit     ;Piep einschalten
entprell6:
 ldi wl,bl_dauer
 mov bl_aus,wl              ;Backlight-Timeout setzen
 sbi bl_port,bl_bit         ;und einschalten
entprellende:
 lds wl,menupara+8          ;Dimmtempo holen
 inc ditz                   ;Dimmzhler hoch
 cp ditz,wl                 ;Grenzwert berschritten?
 brcs hundertstel2          ;nein, noch nicht...
 clr ditz                   ;Dimmzhler lschen
 rcall nachlauf             ;Dimmwerte um max eine Stufe ndern...

hundertstel2:
;Platz fr weitere Jobs im 10ms-Takt

 rjmp mainloop              ;fertig...


neue_sekunde:           ;Job der Mainloop, eine Sekunde vergangen
 cbr jobs,1<<neusek         ;Jobflag lschen
;Timeout LCD-Licht
 tst bl_aus                 ;ist Backlight-Timeout aktiv?
 breq neue_sekunde1         ;nein...
 sbi bl_port,bl_bit         ;ja, Backlight ein
 dec bl_aus                 ;Timeout runter
 brne neue_sekunde1         ;abgelaufen? - nein...
 cbi bl_port,bl_bit         ;ja, Backlight aus 
 blink 0,0,0                ;Blinken aus
 mov mp,ff                  ;Men aus
neue_sekunde1:
; rcall nachlauf     ;debug...
 rjmp mainloop              ;fertig...


;-- Unterprogramme ----------------------------------------------------------- 
nachlauf:               ;UP, Nachlauf und Anzeige der PWM-Werte
 ldi zl,low(pwmist)         ;Pointer auf Anfang
 ldi zh,high(pwmist)        ;Array mit Soll- und Ist-Werten
nachlauf1:
 ldd wh,z+16                ;Sollwert holen
 ld wl,z                    ;Istwert holen
 sub wh,wl                  ;Differenz vorhanden?
 breq nachlauf2             ;nein, fertig...
 sbrs wh,7                  ;
 inc wl                     ;
 sbrc wh,7                  ;
 dec wl                     ;
 st z,wl                    ;
nachlauf2:
 adiw zh:zl,1               ;
 cpi zl,low(pwmist+16)      ;
 brne nachlauf1             ;

pwm_anzeige:            ;Job, gibt aktuelle PWM-Werte am LCD aus
 lds wh,wpos                ;aktuelle Ausgabeposition sichern
 ldi yl,low(pwmist)         ;Pointer auf Anfang
 ldi yh,high(pwmist)        ;Array mit Sollwerten
 locate 0,0                 ;Ausgabeposition setzen
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 locate 1,0                 ;Ausgabeposition setzen
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 locate 2,0                 ;Ausgabeposition setzen
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 locate 3,0                 ;Ausgabeposition setzen
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 rcall pwmprint             ;Datensatz ausgeben
 
; locate 0,0     ;Debug, Anzeige
; print8 mp      ;des Menpunktes

 sts wpos,wh                ;vorherige Ausgabeposition wiederherstellen
 ret                        ;ferig, zurck...

pwmprint:               ;UP, einen Datensatz am LCD ausgeben
 tst mp                     ;Menpunkt 0 (Scrollen in Show-Liste)?
 breq pwmprint2             ;ja, keine PWM-Daten anzeigen...
 ldi wl,12                  ;Menpunkt 12 
 cp mp,wl                   ;(Eingabe Show-Nummer)?
 breq pwmprint2             ;ja, keine PWM-Daten anzeigen...
 ldi wl,13                  ;Menpunkt 13 
 cp mp,wl                   ;(Eingabe Wiederholungen)?
 breq pwmprint2             ;ja, keine PWM-Daten anzeigen...
 sbrs mp,7                  ;Menpunkt negativ (>127)? - ja, volle Anzeige...
 rjmp pwmprint1             ;nein, verkrzte Anzeige...
 mov wl,yl                  ;Kopie vom Pointer
 andi wl,15                 ;als Kanal-Nummer
 ldi tmp,-1+'0'             ;Zehner-Stelle als ASCII-Zeichen, Zahl ber 0
 inc tmp                    ;Zehner hoch und
 subi wl,10                 ;10 subtrahieren bis zum Unterlauf
 brsh pc-2                  ;Unterlauf? nein, 2 Zeilen hoch
 rcall lcd_data             ;Hunderter ausgeben...
 ldi tmp,10+'0'             ;Einer-Stelle als ASCII-Zeichen, Zahl unter 0
 add tmp,wl                 ;
 rcall lcd_data             ;Zehner Stelle ausgeben...
 ldi tmp,'='
 rcall lcd_data
 ldd wl,y+16                ;Datenbyte holen
 ldi tmp,-1+'0'             ;Zehner-Stelle als ASCII-Zeichen, Zahl ber 0
 inc tmp                    ;Zehner hoch und
 subi wl,10                 ;10 subtrahieren bis zum Unterlauf
 brsh pc-2                  ;Unterlauf? nein, 2 Zeilen hoch
 rcall lcd_data             ;Zehner ausgeben...
 ldi tmp,10+'0'             ;Einer-Stelle als ASCII-Zeichen, Zahl unter 0
 add tmp,wl                 ;
 rcall lcd_data             ;Einer Stelle ausgeben...
 ldi tmp,'/'
 rcall lcd_data
pwmprint1:
 ld wl,y+                   ;Datenbyte holen
 ldi tmp,-1+'0'             ;Zehner-Stelle als ASCII-Zeichen, Zahl ber 0
 inc tmp                    ;Zehner hoch und
 subi wl,10                 ;10 subtrahieren bis zum Unterlauf
 brsh pc-2                  ;Unterlauf? nein, 2 Zeilen hoch
 rcall lcd_data             ;Zehner ausgeben...
 ldi tmp,10+'0'             ;Einer-Stelle als ASCII-Zeichen, Zahl unter 0
 add tmp,wl                 ;
 rcall lcd_data             ;Einer Stelle ausgeben...
 ldi tmp,'%'
 rcall lcd_data
 ldi tmp,' '
 rcall lcd_data
pwmprint2:
 ret                        ;zurck...


prili:                  ;UP, printet Listenelement in wl auf LCD
 cpi wl,100                 ;Wertebereich eingehalten?
 brcs prili1                ;ja...
 printf txt_nix             ;nein, Alternativtext ausgeben
 rjmp prili2                ;fertig...
prili1:
 print8 wl                  ;Zahl an LCD ausgeben
prili2:
 ret                        ;zurck...


;-- Interrupt-Service-Routinen (ISRs) ----------------------------------------
TIM1_COMPA:             ;ISR Timer1 (alle 100s)
 in srsk,sreg               ;SREG sichern
 inc pwz                    ;PWM-Zhler hoch
 mov itmp,pwz               ;jedes 4. mal
 andi itmp,3                ;(alle 400s)
 brne kein_update           ;Flag fr LCD-Update
 sbr vflags,1<<upsync       ;setzen
kein_update:
 cpi pwz,pwm_zu             ;PWM-Zhlumfang erreicht?
 brcs kein_top              ;nein...
 ldi pwz,0                  ;mit 0 beginnen 
 sbr jobs,1<<husek          ;Hundertstelsekunde anmelden
kein_top:
 push xl
 push xh
 ldi xl,low(pwmist)         ;Pointer auf Anfang
 ldi xh,high(pwmist)        ;Array mit PWM-Werten
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln (LSB zuerst)
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 out pwm1_port,casa         ;Ports schalten
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln (LSB zuerst)
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 ld itmp,x+                 ;PWM-Wert holen
 cp pwz,itmp                ;vergleichen,
 ror casa                   ;Carry einsammeln
 out pwm2_port,casa         ;Ports schalten
 pop xh
 pop xl
 out sreg,srsk              ;SREG wiederherstellen
 reti                       ;fertig...


;-- Konstanten ---------------------------------------------------------------
txt_badpara:                ;Bedien-Fehlermeldung
.db 2," Parameter ungueltig...",3,0
txt_leerzeile:              ;Leerzeile zum Lschen der Meldung
.db "                        ",1,0
txt_leer16:                 ;Leerzeile mit 16 Zeichen
.db "                ",0,0
txt_save:                   ;Dialogtext Speichern
.db 2," speichere Datensatz...",3,0
txt_ok:                     ;OK-Quittung
.db 2," Befehl ausgefuehrt... ",3,0
txt_nix:
.db " --",0

.include "tasten.inc"       ;Tabelle mit Tastenwerten


maxparalist:                ;Liste mit Maximalwerten der Men-Parameter
.db 0, 63,63,15
.db 99,99, 0, 0
.db  0 ,0 ,0 ,0
.db 99,99, 0, 0


mt:                         ;Indexliste Mentexte
.dw mt0,mt1,mt2,mt3
.dw mt4,mt5,mtr,mtr
.dw mtr,mtr,mt10,mt11
.dw mt12,mt13,mt14,mt15

mt0:    .db 4,   "Pos.Show Rpt.   Home    Up 1    Up 10 ",13
        .db      "                Delete  Show-Nr Repeat ",13
        .db      "                End     Down 1  Down 10",13
        .db      "                Abbruch Del.all Start ",1,0

mt1:    .db 9,16,"1 Dimmwerte laden       ",9,56
        .db      "Speicherplatz-Nr        ",9,96
        .db      "(00-63):",1,0

mt2:    .db 9,16,"2 Dimmwerte speichern   ",9,56
        .db      "Speicherplatz-Nr        ",9,96
        .db      "(00-63):",1,0

mt3:    .db 9,16,"3 Auswahl PWM-Kanal     ",9,56
        .db      "Kanal-Nr                ",9,96
        .db      "(00-15):",1,0

mt4:    .db 9,16,"4 Dimmwert Kanal ",13,9,56
        .db      "einstellen              ",9,96
        .db      "(00-99):",1,0

mt5:    .db 9,16,"5 Dimmtempo beim Wechsel",9,56
        .db      "der Dimmwerte           ",9,96
        .db      "(00-99):",1,0

mt10:   .db 9,56,"16-Kanal-Lichtsteuerung ",9,96
        .db      " (c)  www.hanneslux.de  ",1,0

mt11:   .db 9,16,"1 Laden     2 Saven     ",9,56
        .db      "3 PWM-Kanal 4 Dimmwert  ",9,96
        .db      "5 Dimmtempo, statisch   ",9,136
        .db      "0 Dynam. Lichtsteuerung ",1,0

mt12:   .db 9,16,"5 Lichtshow zur Liste   ",9,56
        .db      "hinzufuegen             ",9,96
        .db      "(00-99):",1,0

mt13:   .db 9,16,"7 Anzahl Wiederholungen ",9,56
        .db      "der Lichtshow           ",9,96
        .db      "(00-99):",1,0

mt14:

mt15:

mtr:    .db 9,16,"Reserviert fuer         ",9,56
        .db      "spaetere Erweiterungen..",0,0

